<template>
  <div class="sw-gs-device-settings-wrapper">
    <template v-if="microphoneCount > 0">
      <div class="sw-gs-audio-input-wrapper">
        <SfSelect :label="$t('Microphone')" v-model="microphoneDevice">
          <SfSelectOption v-for="device in mediaDevices.audioInput" :key="device.deviceId" :value="device.deviceId">
            {{ device.label }}
          </SfSelectOption>
        </SfSelect>
      </div>
    </template>

    <template v-if="speakerCount > 0">
      <div class="sw-gs-audio-output-wrapper">
        <SfSelect :label="$t('Speaker')" v-model="speakerDevice">
          <SfSelectOption v-for="device in mediaDevices.audioOutput" :key="device.deviceId" :value="device.deviceId">
            {{ device.label }}
          </SfSelectOption>
        </SfSelect>
      </div>
    </template>

    <template v-if="videoChatEnabled && cameraCount > 0 && !isAudioOnly">
      <div class="sw-gs-video-input-wrapper">
        <SfSelect :label="$t('Camera')" v-model="cameraDevice">
          <SfSelectOption v-for="device in mediaDevices.videoInput" :key="device.deviceId" :value="device.deviceId">
            {{ device.label }}
          </SfSelectOption>
        </SfSelect>
      </div>
    </template>

    <template v-if="isAudioOnly">
      <SwButton class="sw-gs-video-rejoin color-light" @click="rejoinWithVideo">
        {{$t('rejoin with video')}}
      </SwButton>
    </template>

  </div>
</template>

<script lang="ts">
  import { SfSelect } from "@storefront-ui/vue"
  import SwButton from "@/components/atoms/SwButton.vue";
  import { useMediaDevices } from '../logic/composables/useMediaDevices';
  import { useVideoCall } from '../logic/composables/useVideoCall';

  export default {
    name: "SwGsDeviceSettings",
    components: {
      SfSelect,
      SwButton,
    },

    setup() {
      const {
        getMediaDevices,
        mediaDevices,
        cameraCount,
        microphoneCount,
        speakerCount,
        microphoneDevice,
        speakerDevice,
        cameraDevice,
        isAudioOnly,
        clearDeviceState,
      } = useMediaDevices();

      const { videoChatEnabled } = useVideoCall();

      getMediaDevices();

      function rejoinWithVideo() {
        clearDeviceState();
        setTimeout(() => {
          location.reload()
        }, 250);
      }

      return {
        videoChatEnabled,
        rejoinWithVideo,
        microphoneDevice,
        speakerDevice,
        cameraDevice,
        mediaDevices,
        cameraCount,
        microphoneCount,
        speakerCount,
        isAudioOnly,
      }
    }
  }
</script>

<style lang="scss" scoped>

  ::v-deep .sw-gs-audio-input-wrapper,
  .sw-gs-audio-output-wrapper,
  .sw-gs-video-input-wrapper {
    height: 50px;
  }

  ::v-deep {
    .sf-select__label {
      font-size: 14px;
      font-weight: bold;
    }

    .sf-select__dropdown {
      font-size: 12px;
    }

    .sf-select__error-message {
      display: none;
    }
  }

  .sw-gs-video-rejoin {
    margin-top: 10px;
    border-radius: 10px;
  }

</style>
